//+------------------------------------------------------------------+
//|                       Macd Alert.mq4 MTF                         |
//|                                                                  | 
//|                                                                  |
//|                                                                  |                  
//+------------------------------------------------------------------+


#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 LawnGreen
#property indicator_color2 Red
#property indicator_width1  1
#property indicator_width2  1

extern int timeFrame    = 0;
extern int MACD_Fast    = 12;
extern int MACD_Slow    = 26;
extern int MACD_Slowing = 9; 

extern bool AlertON=false;
extern bool EmailON=false;
extern double arrowDisplacementA = 1.5;
extern double arrowDisplacementB = 1.5;

double CrossUp[];
double CrossDown[];
int flagval1=0;
int flagval2=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_ARROW, EMPTY);
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, CrossUp);
   SetIndexStyle(1, DRAW_ARROW, EMPTY);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, CrossDown);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
  int start() 
  {
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit=MathMax(Bars-counted_bars,3*timeFrame/Period());
         static datetime lastTime = 0;
         static string   lastType = "";
   
   //
   //
   //
   //
   //
  
   for (int i=limit;i>=0;i--)
   {
      CrossUp[i]=EMPTY_VALUE;
      CrossDown[i]=EMPTY_VALUE;

      //
      //
      //
      //
      
      int y = iBarShift(NULL,timeFrame,Time[i]);
      int x = iBarShift(NULL,timeFrame,Time[i+1]);
      if (x==y) continue;
      
      double Range            = iATR(NULL,0,10,i);
      double macdnow          = iMACD(NULL,timeFrame, MACD_Fast, MACD_Slow, MACD_Slowing, PRICE_CLOSE, MODE_MAIN,y);
      double macdprevious     = iMACD(NULL,timeFrame, MACD_Fast, MACD_Slow, MACD_Slowing, PRICE_CLOSE, MODE_MAIN,y+1);
      double macd_signow      = iMACD(NULL,timeFrame, MACD_Fast, MACD_Slow, MACD_Slowing, PRICE_CLOSE, MODE_SIGNAL,y);
      double macd_sigprevious = iMACD(NULL,timeFrame, MACD_Fast, MACD_Slow, MACD_Slowing, PRICE_CLOSE, MODE_SIGNAL,y+1);
      
      
         
            if ((macdnow > macd_signow) && (macdprevious < macd_sigprevious)) 
            {
               if (i ==1 && lastTime!=Time[0] || lastType!="long")
               {
                  lastTime = Time[0];
                  lastType = "long";
                  if (AlertON) Alert(Symbol()," - ",timeFrame," - STC :: LONG :: @ ",TimeHour(CurTime()),":",TimeMinute(CurTime()));
                  if (EmailON) SendMail("BUY signal alert","BUY signal at Ask="+DoubleToStr(Ask,4)+", Bid="+DoubleToStr(Bid,4)+", Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
               }
               CrossUp[i]=Low[i] - arrowDisplacementA*iATR(NULL,0,20,i);
            }
      

            if ((macdnow < macd_signow) && (macdprevious > macd_sigprevious)) 
            {
               if (i ==1 && lastTime!=Time[0] || lastType!="short")
               {
                  lastTime = Time[0];
                  lastType = "short";
                  if (AlertON) Alert(Symbol()," - ",timeFrame," - STC :: SHORT :: @ ",TimeHour(CurTime()),":",TimeMinute(CurTime()));
                  if (EmailON) SendMail("SELL signal alert","SELL signal at Ask="+DoubleToStr(Ask,4)+", Bid="+DoubleToStr(Bid,4)+", Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
               }
               CrossDown[i]=High[i] + arrowDisplacementB*iATR(NULL,0,20,i);
            }
     }
   return(0);
}